/* FontList 1.1 (c) 28.10.1996 Lubos Nemec, pure ASCII version, FREEWARE
   Make fontlist with all available fonts installed in PGS3 preferences
   "System Preferences/Fonts". This script is created for page A4 portrait.
   You can alter page margins in "page margins" section in this scripts.
   
   Advise presets: font size:                4-36 points (preset is 8 points)
                   font width:              40-150%      (preset is 100%)
                   leading [relative]:     100-200%      (preset is 120%)
                   EmptyLine between fonts:  0-50 points (preset is 3 points)
                   Page margins:             1 cm from all borders (preset is 1 cm)
                   Number of columns:        1-2         (preset is 1 column)
                   Space between columns:    5-50        (not used)
                   Maximum pages:  limited only with free memory (preset is 500)
*/



address 'PAGESTREAM'
options results
trace on

/* page margins in milimeters & maximum pages number */

left=10
right=10
top=10
bottom=10
column=1
gutter=5
maxpages=500

/* main script */

setautocolumns off
display page 1
'getstring string "8" title "Size" posbutton "_OK" negbutton "_Cancel"'
size=RESULT; button=RC
if RC=10 then exit
if size>36 then exit
if size<4 then exit
'getstring string "100" title "Width" posbutton "_OK" negbutton "_Cancel"'
width=RESULT; button=RC
if RC=10 then exit
if width<40 then exit
if width>150 then exit
'getstring string "120" title "Leading" posbutton "_OK" negbutton "_Cancel"'
leading=RESULT; button=RC
if RC=10 then exit
if leading<100 then exit
if leading>200 then exit
'getstring string "3" title "EmptyLine" posbutton "_OK" negbutton "_Cancel"'
space=RESULT; button=RC
if RC=10 then exit
if space<0 then exit
if space>50 then exit


getfontlist jmeno
pocet=result

settypesize size; settypewidth width
createcolumns margins left''mm right''mm top''mm bottom''mm columns column gutter gutter''mm linked page 1 to 1
settoolmode text; selecttext at left+5''mm top+5''mm frontmost

openbusyrequester message "'Making FontList...'" thermometer enabled abort enabled total pocet current 0
bh=RESULT
do x=0 to pocet-1
settypesize size; settypewidth width; setleading relative leading
'setfont "'jmeno.x'"'
'insert "'jmeno.x'"'
'insert "  'size' points   0123456789"'
insertcontrol newparagraph
'insert "!#$%&()*+,-./:;<=>?@ABCDEFGHIKLMNOPQRSTUVWXYZ[\]^_abcdefghijklmnopqrstuvwxyz{|}~"'
insertcontrol newparagraph
settypesize space; setleading fixed space; 'insert " "'; insertcontrol newparagraph

getbusyrequester bh
if result=1 then do
   closebusyrequester bh
   do y=1 to maxpages
     getarticleoverset
      if result=TRUE then do
           display page next; settoolmode column
           createcolumns margins left''mm right''mm top''mm bottom''mm columns column gutter gutter linked page y+1 to y+1
           settoolmode routetext; settextrouting from left+5''mm top+5''mm page y to left+5''mm top+5''mm page y+1
           settoolmode text; selecttext at left+5''mm right+5''mm frontmost
      end
       else do
            display page 1; settoolmode object; exit
            end
   end y
 end 
   else setbusyrequester bh current x+1
end x
closebusyrequester bh

do y=1 to maxpages
getarticleoverset
if result=TRUE then do
   display page next; settoolmode column
   createcolumns margins left''mm right''mm top''mm bottom''mm columns column gutter gutter linked page y+1 to y+1
   settoolmode routetext; settextrouting from left+5''mm top+5''mm page y to left+5''mm top+5''mm page y+1
   settoolmode text; selecttext at left+5''mm top+5''mm frontmost
   end
else do
     display page 1; settoolmode object; exit
     end
end
display page 1
settoolmode object
